<template>
  <data-table ref="datatable" :get-data="fetchData">
    <template slot="table-toolbar">
      <h1 class="md-title">Whitelist</h1>

      <md-field md-clearable class="md-toolbar-section-end">
        <md-input placeholder="Search" v-model="search" @input="searchWhitelists" />
      </md-field>
    </template>

    <md-table-head>#</md-table-head>
    <md-table-head>Whitelist ID</md-table-head>
    <md-table-head>Name</md-table-head>
    <md-table-head>Email</md-table-head>
    <md-table-head>ETH address</md-table-head>
    <md-table-head>ETH amount</md-table-head>

    <template slot="body" slot-scope="{ item, index }">
      <md-table-row >
        <md-table-cell> {{ index + 1 }}</md-table-cell>
        <md-table-cell>{{ item.id }}</md-table-cell>
        <md-table-cell>{{ item.name }}</md-table-cell>
        <md-table-cell>{{ item.email }}</md-table-cell>
        <md-table-cell>{{ item.eth_address }}</md-table-cell>
        <md-table-cell>{{ item.eth_amount | formatCurrencyAmount('eth', '0') }}</md-table-cell>
      </md-table-row>
    </template>
  </data-table>
</template>
<script>
import rf from '../../../common/requests/RequestFactory';

export default {
  data () {
    return {
      search: '',
    };
  },
  methods: {
    searchWhitelists: _.debounce(function () {
      this.refreshDataTable();
    }, 500),

    async fetchData (params) {
      const meta = {
        like_operator: 'or',
        like: {
          name: this.search,
          email: this.search,
          eth_address: this.search,
          eth_amount: this.search,
        },
      };
      return rf.getRequest('WhitelistRequest').getAll(Object.assign({}, params, meta));
    },

    refreshDataTable () {
      this.$refs.datatable.refresh();
    }
  },
};
</script>

<style lang="scss" scoped>
  .md-field {
    max-width: 400px;
  }

  .md-card .md-card-content {
    padding: 0px 20px;
  }

  .md-card {
    margin: 0px;
  }
</style>
